#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define int int64_t

const int MAXN = 2e5 + 100;

vector <int> gr[MAXN];

int n, m;

/*int deepest = 0;

void dfs1(int v, int deep = 0) {
    for (int i = 0; i < (int)gr[v].size(); i++)
        dfs1(gr[v][i], deep + 1);
    deepest = max(deepest, deep);
}*/

int res[MAXN];
void dfs2(int v) {
    res[v] = 0;
    for (int i = 0; i < (int)gr[v].size(); i++) {
        int to = gr[v][i];
        dfs2(to);
        res[v] = max(res[v], res[to] + 1);
    }

    /*if ((int)gr[v].size() == 0)
        res[v] = (deepest + 1) * (m - 1);*/
}

int get_res(int v) {
    int max1 = 0, max2 = 0;
    for (int i = 0; i < (int)gr[v].size(); i++) {
        int cur = res[gr[v][i]] + 1;
        if (max1 < cur)
            max2 = max1, max1 = cur;
        else if (max2 < cur)
            max2 = cur;
    }

    return max1 + max2 + 1;
}

int32_t main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stout));

    ios_base::sync_with_stdio(false);

    cin >> n >> m;
    for (int i = 1; i < n; i++) {
        int p; cin >> p; p--;
        gr[p].push_back(i);
    }

    //dfs1(0);
    dfs2(0);

    int answer = 0;
    for (int i = 0; i < n; i++) {
        answer = max(answer, get_res(i));
        //cout << "get_res(" << i + 1 << ") = " << get_res(i) << endl;
    }

    cout << answer << endl;

    return 0;
}
