#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define int int64_t

int k;
vector <pair <pair <int, int>, int> > c;

vector <int> get_all(int l, int r) {
    vector <int> all;
    for (int i = 0; i < (int)c.size(); i++)
        if (c[i].first.first <= r && c[i].first.second >= l)
            all.push_back(c[i].second);
    sort(all.begin(), all.end());
    all.resize(unique(all.begin(), all.end()) - all.begin());
    return all;
}

map <pair <pair <int, int>, int>, int> was;

int get_dp(int l, int r, int c) {
    if (was.count(make_pair(make_pair(l, r), c)))
        return was[make_pair(make_pair(l, r), c)];
    vector <int> p = get_all(l, r);

    if ((int)p.size() == 1) {
        was[make_pair(make_pair(l, r), c)] = (c != p[0]);
        return c != p[0];
    }

    int m = (l + r) / 2;
    int res = get_dp(l, m, c) + get_dp(m + 1, r, c);
    for (int i = 0; i < (int)p.size(); i++)
        if (p[i] != c)
            res = min(res, get_dp(l, m, p[i]) + get_dp(m + 1, r, p[i]) + 1);

    was[make_pair(make_pair(l, r), c)] = res;

    return res;
}

int32_t main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stout));

    ios_base::sync_with_stdio(false);

    int t, m; cin >> k >> t >> m;
    for (int i = 0; i < t; i++) {
        int a, val; cin >> a >> val;
        if (!c.empty() && c.back().second == val)
            c.back().first.second += a;
        else {
            if (!c.empty())
                c.push_back(make_pair(make_pair(c.back().first.second + 1, c.back().first.second + a), val));
            else
                c.push_back(make_pair(make_pair(0, a - 1), val));
        }
    }

    cout << get_dp(0, (1 << k) - 1, 0) << endl;

    return 0;
}
