#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <vector>

using namespace std;

#define int int64_t

int a, b, k;

int get_sqrt(int x) {
    int res = sqrt(x);
    while ((res + 1) * (res + 1) <= x)
        res++;
    while (res * res > x)
        res--;
    return res;
}

int get(int a, int b) { return get_sqrt(b) - get_sqrt(a - 1); }

int32_t main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stout));

    ios_base::sync_with_stdio(false);

    cin >> a >> b >> k;

    int res = 0;
    for (int y = 1; y * y * y <= b; y++) {
        int cur = y * y * y;
        if (cur >= a)
            res += get(max(a, cur - k), min(b, cur + k));
    }

    cout << res << endl;

    return 0;
}
