#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define int int64_t

const int MAXN = 1e5;
const int INF = 1e18;

vector <pair <int, char> > gr[MAXN];
map <string, int> p;

vector <pair <int, string> > f;

int32_t main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stout));

    ios_base::sync_with_stdio(false);

    int n, m, t; cin >> n >> m >> t;
    for (int i = 1; i < n; i++) {
        int p; cin >> p; p--;
        char k; cin >> k;
        gr[p].push_back(make_pair(i, k));
    }
    bool flag = true;

    for (int i = 0; i < m; i++) {
        int cost; cin >> cost;
        string cur; cin >> cur;
        if (p.count(cur))
            p[cur] = min(p[cur], cost);
        else
            p[cur] = cost;
        if ((int)cur.length() > 1)
            flag = false;
        f.push_back(make_pair(cost, cur));
    }

    if (flag) {
        int res = 0;
        for (int i = 0; i < n; i++)
            for (int j = 0; j < (int)gr[i].size(); j++) {
                string h = "";
                h += gr[i][j].second;
                res += p[h];
            }
        cout << res << endl;
    } else {
        string s = "";
        for (int i = 0; i < n - 1; i++)
            s += gr[i][0].second;
        n--;

        vector <int> dp;
        dp.resize(n + 1, INF);
        dp[0] = 0;
        for (int i = 0; i < n; i++) {
            for (int j = i; j < n; j++) {
                string cur = "";
                int kek = INF;
                for (int p = i; p <= j; p++) {
                    cur += s[p];
                    kek = min(kek, dp[p]);
                }
                if (p.count(cur))
                    dp[j + 1] = min(dp[j + 1], kek + p[cur]);
            }
        }

        cout << dp[n] << endl;
    }

    return 0;
}
