#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define int int64_t

const int MAXN = 1e5;
const int INF = 1e18;

vector <pair <int, char> > gr[MAXN];
map <string, int> p;

vector <pair <int, string> > f;

int32_t main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stout));

    ios_base::sync_with_stdio(false);

    int n, m, t; cin >> n >> m >> t;
    string h = "";
    bool flag2 = true;
    for (int i = 1; i < n; i++) {
        int p; cin >> p; p--;
        if (p + 1 != i)
            flag2 = false;
        char k; cin >> k;
        h += k;
        gr[p].push_back(make_pair(i, k));
    }
    bool flag1 = true;

    for (int i = 0; i < m; i++) {
        int cost; cin >> cost;
        string cur; cin >> cur;
        if (p.count(cur))
            p[cur] = min(p[cur], cost);
        else
            p[cur] = cost;
        if ((int)cur.length() > 1)
            flag1 = false;
        f.push_back(make_pair(cost, cur));
    }

    if (flag1) {
        int res = 0;
        for (int i = 0; i < n; i++)
            for (int j = 0; j < (int)gr[i].size(); j++) {
                string h = "";
                h += gr[i][j].second;
                res += p[h];
            }
        cout << res << endl;
    } else if (flag2) {
        n = (int)h.size();
        vector <int> dp(n + 1, INF);
        dp[0] = 0;
        for (int j = 0; j < n; j++)
            for (int i = 0; i <= j; i++) {
                string cur = "";
                int kek = INF;
                for (int p = i; p <= j; p++) {
                    cur += h[p];
                    kek = min(kek, dp[p]);
                }
                if (p.count(cur))
                    dp[j + 1] = min(dp[j + 1], kek + p[cur]);
            }

        if (dp[n] >= INF)
            cout << -1 << endl;
        else
            cout << dp[n] << endl;
    } else
        cout << -1 << endl;

    return 0;
}
