#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define int int64_t

const int INF = 1e18;

int k, s;

int32_t main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stout));

    ios_base::sync_with_stdio(false);

    cin >> k >> s;

    int cur = 0, ans = INF;
    for (int cnt = 1; cur + k + cnt <= s; cnt++) {
        cur += (k + cnt);
        int curans = (s - cur + cnt - 1) / cnt + k;
        ans = min(ans, curans);
    }

    cout << ans << endl;

    return 0;
}
